
/*
*	$Id: draw.h,v 1.3 1998/02/20 01:00:16 manchek Exp $
*
*	11 Nov 1996 Robert Manchek manchek@spiderplant.com
*/

/*
*  Copyright (C) 1995, 1996 by Robert Manchek.  (manchek@spiderplant.com)
*
*  Permission to use, copy, modify, and distribute this software
*  and its documentation for any purpose and without fee is hereby
*  granted, provided that this copyright notice appear in all
*  copies and that both that copyright notice and this permission
*  notice appear in supporting documentation.
*
*  This software is provided "as is" without express or implied
*  warranty.
*/

/*
*	$Log: draw.h,v $
*	Revision 1.3  1998/02/20 01:00:16  manchek
*	added length param to img_textwidth
*
*	Revision 1.2  1996/11/12 06:13:57  manchek
*	fixed typo in prototype
*
*	Revision 1.1  1996/11/12 05:19:19  manchek
*	Initial revision
*
*/

/*
*	pixel and image descriptions, so we can draw stuff
*/

struct pixel {
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;
};

struct img {
	int wd;
	int ht;
	struct pixel *data;		/* wd * ht */
};


#ifdef _PT_
#undef _PT_
#endif
#ifdef __STDC__
#define _PT_(x) x
#else
#define _PT_(x) ()
#endif

struct img *img_new _PT_(( int wd, int ht ));
int img_plot _PT_(( struct img *imp, struct pixel px, int x, int y ));
int img_drawline _PT_(( struct img *imp, struct pixel px,
		int x1, int y1, int x2, int y2 ));
int img_drawchar _PT_(( struct img *imp, struct pixel *cp1,
		struct pixel *cp2, int x, int y, char c ));
int img_drawstring _PT_(( struct img *imp, struct pixel *cp1,
		struct pixel *cp2, int x, int y, char *s, int l ));
int img_textwidth _PT_(( struct img *imp, char *s, int l ));
int img_fontattr _PT_(( int *asc, int *des ));
int img_blend _PT_(( struct img *front, struct img *back, struct img *dest ));
int img_write _PT_(( char *name, FILE *ff, struct img *imp ));
struct img *img_read _PT_(( char *name, FILE *ff ));
int parsecolor _PT_(( char *name, struct pixel *col ));
int img_shadow _PT_(( struct img *imp, double dx, double dy,
		struct pixel scolor ));

